#include "stdio.h"

#define INF -1




typedef struct{ int c1, c2, c3, c4; } Pocty;

static Pocty C; 

int sucet(Pocty P)
{ 
	if (P.c1==INF || P.c2==INF || P.c3==INF || P.c4==INF)
		return INF;
	return P.c1+P.c2+P.c3+P.c4;
}

int suma(Pocty P)
{ 
	if (P.c1==INF || P.c2==INF || P.c3==INF || P.c4==INF)
		return INF;
	return P.c1+5*P.c2+10*P.c3+25*P.c4;
}

Pocty solve1(int p)
{
	Pocty A={INF, INF, INF, INF};
	if (p<0) return A;
	if (C.c1<p) return A;	
	A.c1=p;
	return A;
}



Pocty solve2(int p)
{
	Pocty A={INF, INF, INF, INF};
	int s = C.c1*1;
	int n;

	if (p<0) return A;
	n=(p-s+4)/5;
	if (n<0) n=0;
	if (C.c2<n) return A;
	A=solve1(p-n*5);
	A.c2=n;
	return A;
}


Pocty solve3(int p)
{
	Pocty A={INF, INF, INF, INF};
	int s = C.c1*1+C.c2*5;
	int n;

	if (p<0) return A;
	n=(p-s+9)/10;
	if (n<0) n=0;
	if (C.c3<n) return A;	
	A=solve2(p-n*10);
	A.c3=n;
	return A;
}



Pocty solve4(int p)
{
	Pocty A={INF, INF, INF, INF};
	Pocty B={INF, INF, INF, INF};
	int s = C.c1*1+C.c2*5 + C.c3*10;
	int n;

	if (p<0) return A;
	n=(p-s+24)/25;
	if (n<0) n=0;
	if (C.c4<n) return A;

	A=solve3(p-n*25);
	A.c4=n;
	
	if (C.c4<n+1) return A;
	B=solve3(p-(n+1)*25);
	B.c4=n+1;
	
	if (sucet(A)>sucet(B)) return A; else return B;
}



int main(void)
{
	while (1) {
		int p;
		Pocty R;

		scanf("%d %d %d %d %d ", &p, &C.c1, &C.c2, &C.c3, &C.c4);
		if (C.c1==0 && C.c2==0 && C.c3==0 && C.c4==0 && p==0)
			break;

		R=solve4(p);
		
		
/*		printf("!!!!Throw in %d cents, %d nickels, %d dimes, and %d quarters %d %d.\n", R.c1, R.c2, R.c3, R.c4, p);*/
		if ((suma(R)==INF) || (suma(R)!=p ))
			printf("Charlie cannot buy coffee.\n");
		else
			printf("Throw in %d cents, %d nickels, %d dimes, and %d quarters.\n", R.c1, R.c2, R.c3, R.c4);
		
	}
	return 0;
}
