#include "stdio.h"

#define INF 999999999

int solve(int a, int b, int c, int d, int e, int f)
{
	int cuts=0;

	if (a*c>e) return INF;
	if (b*d>f) return INF;

	if (e-(a*c)!=0) cuts++;
	if (f-(b*d)!=0) cuts++;

	return cuts+a*b-1;
}

int main(void)
{
	int a,b,c,d,e,f,min,x;
	while (1) {
		scanf("%d %d %d %d %d %d ", &a, &b, &c, &d, &e, &f);
		if (a==0 && b==0 && c==0 && d==0 && e==0 && f==0)
			break;

		min=INF;

		x=solve(a,b,c,d,e,f);
		if (x<min) min=x;
		
		x=solve(a,b,d,c,e,f);
		if (x<min) min=x;
		
		x=solve(b,a,c,d,e,f);
		if (x<min) min=x;
		
		x=solve(b,a,d,c,e,f);
		if (x<min) min=x;
		
		if (min<INF) 
			printf("The minimum number of cuts is %d.\n", min);
		else
			printf("The paper is too small.\n");
	}
	return 0;
}
